Index: uspace/srv/net/dnsrsrv/transport.c
===================================================================
--- uspace/srv/net/dnsrsrv/transport.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/dnsrsrv/transport.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #include <adt/list.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/addr.h>
@@ -199,5 +200,5 @@
 		    req_size);
 		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_DEBUG, "Error %d sending message", rc);
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Error sending message: %s", str_error(rc));
 			goto error;
 		}
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,4 +39,5 @@
 #include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/iplink_srv.h>
@@ -280,5 +281,5 @@
 	free(data);
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_received() done, rc=%d", rc);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_received() done, rc=%s", str_error_name(rc));
 	async_answer_0(callid, rc);
 }
@@ -328,5 +329,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering callback for NIC "
-		    "discovery (%d).", rc);
+		    "discovery: %s.", str_error(rc));
 		return rc;
 	}
@@ -357,5 +358,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_send(size=%zu)", size);
 	rc = nic_send_frame(nic->sess, data, size);
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "nic_send_frame -> %d", rc);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "nic_send_frame -> %s", str_error_name(rc));
 	return rc;
 }
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 #include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/iplink.h>
@@ -114,5 +115,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "call inet_recv_packet()");
 	rc = inet_recv_packet(&packet);
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "call inet_recv_packet -> %d", rc);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "call inet_recv_packet -> %s", str_error_name(rc));
 	free(packet.data);
 
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <io/log.h>
@@ -105,5 +106,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		return EEXIST;
 	}
@@ -112,5 +113,5 @@
 	rc = loc_service_register(SERVICE_NAME_INET, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
 	}
Index: uspace/srv/net/inetsrv/ndp.c
===================================================================
--- uspace/srv/net/inetsrv/ndp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/inetsrv/ndp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 #include <errno.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/log.h>
 #include "ntrans.h"
Index: uspace/srv/net/loopip/loopip.c
===================================================================
--- uspace/srv/net/loopip/loopip.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/loopip/loopip.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <inet/iplink_srv.h>
 #include <inet/addr.h>
@@ -251,11 +252,13 @@
 	int rc = log_init(NAME);
 	if (rc != EOK) {
-		printf("%s: Failed to initialize logging.\n", NAME);
+		printf("%s: Failed to initialize logging: %s.\n", NAME, str_error(rc));
 		return rc;
 	}
 	
 	rc = loopip_init();
-	if (rc != EOK)
-		return rc;
+	if (rc != EOK) {
+		printf("%s: Failed to initialize loopip: %s.\n", NAME, str_error(rc));
+		return rc;
+	}
 	
 	printf("%s: Accepting connections.\n", NAME);
Index: uspace/srv/net/nconfsrv/iplink.c
===================================================================
--- uspace/srv/net/nconfsrv/iplink.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/nconfsrv/iplink.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 #include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/dhcp.h>
@@ -181,5 +182,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering callback for IP link "
-		    "discovery (%d).", rc);
+		    "discovery: %s.", str_error(rc));
 		return rc;
 	}
Index: uspace/srv/net/nconfsrv/nconfsrv.c
===================================================================
--- uspace/srv/net/nconfsrv/nconfsrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/nconfsrv/nconfsrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/dhcp.h>
@@ -80,5 +81,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		return EEXIST;
 	}
@@ -86,5 +87,5 @@
 	rc = loc_service_register(SERVICE_NAME_NETCONF, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
 	}
Index: uspace/srv/net/slip/slip.c
===================================================================
--- uspace/srv/net/slip/slip.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/slip/slip.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,10 +37,12 @@
 #include <stdio.h>
 #include <stdint.h>
+#include <stdlib.h>
 #include <loc.h>
 #include <inet/addr.h>
 #include <inet/iplink_srv.h>
-#include <char_dev_iface.h>
+#include <io/chardev.h>
 #include <io/log.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 
@@ -96,29 +98,29 @@
 }
 
-static void write_flush(async_sess_t *sess)
+static void write_flush(chardev_t *chardev)
 {
 	size_t written = 0;
 
 	while (slip_send_pending > 0) {
-		ssize_t size;
-
-		size = char_dev_write(sess, &slip_send_buf[written],
-		    slip_send_pending);
-		if (size < 0) {
+		int rc;
+		size_t nwr;
+
+		rc = chardev_write(chardev, &slip_send_buf[written],
+		    slip_send_pending, &nwr);
+		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR,
-			    "char_dev_write() returned %d",
-			    (int) size);
+			    "chardev_write() -> %s", str_error_name(rc));
 			slip_send_pending = 0;
 			break;
 		}
-		written += size;
-		slip_send_pending -= size;
-	}
-}
-
-static void write_buffered(async_sess_t *sess, uint8_t ch)
+		written += nwr;
+		slip_send_pending -= nwr;
+	}
+}
+
+static void write_buffered(chardev_t *chardev, uint8_t ch)
 {
 	if (slip_send_pending == sizeof(slip_send_buf))
-		write_flush(sess);
+		write_flush(chardev);
 	slip_send_buf[slip_send_pending++] = ch;
 }
@@ -128,5 +130,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "slip_send()");
 	
-	async_sess_t *sess = (async_sess_t *) srv->arg;
+	chardev_t *chardev = (chardev_t *) srv->arg;
 	uint8_t *data = sdu->data;
 	
@@ -136,24 +138,24 @@
 	 * measure for dealing with previous possible noise on the line.
 	 */
-	write_buffered(sess, SLIP_END);
+	write_buffered(chardev, SLIP_END);
 	
 	for (size_t i = 0; i < sdu->size; i++) {
 		switch (data[i]) {
 		case SLIP_END:
-			write_buffered(sess, SLIP_ESC);
-			write_buffered(sess, SLIP_ESC_END);
+			write_buffered(chardev, SLIP_ESC);
+			write_buffered(chardev, SLIP_ESC_END);
 			break;
 		case SLIP_ESC:
-			write_buffered(sess, SLIP_ESC);
-			write_buffered(sess, SLIP_ESC_ESC);
+			write_buffered(chardev, SLIP_ESC);
+			write_buffered(chardev, SLIP_ESC_ESC);
 			break;
 		default:
-			write_buffered(sess, data[i]);
+			write_buffered(chardev, data[i]);
 			break;
 		}
 	}
 	
-	write_buffered(sess, SLIP_END);
-	write_flush(sess);
+	write_buffered(chardev, SLIP_END);
+	write_flush(chardev);
 	
 	return EOK;
@@ -203,17 +205,21 @@
 }
 
-static uint8_t read_buffered(async_sess_t *sess)
+static uint8_t read_buffered(chardev_t *chardev)
 {
 	while (slip_recv_pending == 0) {
-		ssize_t size;
-
-		size = char_dev_read(sess, slip_recv_buf,
-		    sizeof(slip_recv_buf));
-		if (size < 0) {
+		int rc;
+		size_t nread;
+
+		rc = chardev_read(chardev, slip_recv_buf,
+		    sizeof(slip_recv_buf), &nread);
+		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR,
-			    "char_dev_read() returned %d", (int) size);
+			    "char_dev_read() -> %s", str_error_name(rc));
+		}
+
+		if (nread == 0)
 			return SLIP_END;
-		}
-		slip_recv_pending = size;
+
+		slip_recv_pending = nread;
 		slip_recv_read = 0;
 	}
@@ -224,5 +230,5 @@
 static int slip_recv_fibril(void *arg)
 {
-	async_sess_t *sess = (async_sess_t *) arg;
+	chardev_t *chardev = (chardev_t *) arg;
 	static uint8_t recv_final[SLIP_MTU];
 	iplink_recv_sdu_t sdu;
@@ -234,5 +240,5 @@
 	while (true) {
 		for (sdu.size = 0; sdu.size < sizeof(recv_final); /**/) {
-			ch = read_buffered(sess);
+			ch = read_buffered(chardev);
 			switch (ch) {
 			case SLIP_END:
@@ -246,9 +252,9 @@
 
 			case SLIP_ESC:
-				ch = read_buffered(sess);
+				ch = read_buffered(chardev);
 				if (ch == SLIP_ESC_END) {
 					recv_final[sdu.size++] = SLIP_END;
 					break;
-				} else if (ch ==  SLIP_ESC_ESC) {
+				} else if (ch == SLIP_ESC_ESC) {
 					recv_final[sdu.size++] = SLIP_ESC;
 					break;
@@ -281,5 +287,5 @@
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR,
-			    "iplink_ev_recv() returned %d", rc);
+			    "iplink_ev_recv() -> %s", str_error_name(rc));
 		}
 	}
@@ -295,4 +301,6 @@
 	async_sess_t *sess_in = NULL;
 	async_sess_t *sess_out = NULL;
+	chardev_t *chardev_in = NULL;
+	chardev_t *chardev_out = NULL;
 	fid_t fid;
 	int rc;
@@ -336,5 +344,13 @@
 		return ENOENT;
 	}
-	slip_iplink.arg = sess_out;
+
+	rc = chardev_open(sess_out, &chardev_out);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "Failed opening character device.");
+		return ENOENT;
+	}
+
+	slip_iplink.arg = chardev_out;
 
 	sess_in = loc_service_connect(svcid, INTERFACE_DDF, 0);
@@ -347,4 +363,11 @@
 	}
 
+	rc = chardev_open(sess_in, &chardev_in);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "Failed opening character device.");
+		return ENOENT;
+	}
+
 	rc = loc_service_register(linkstr, &linksid);
 	if (rc != EOK) {
@@ -363,5 +386,5 @@
 	}
 
-	fid = fibril_create(slip_recv_fibril, sess_in);
+	fid = fibril_create(slip_recv_fibril, chardev_in);
 	if (!fid) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
@@ -375,6 +398,8 @@
 
 fail:
+	chardev_close(chardev_out);
 	if (sess_out)
 		async_hangup(sess_out);
+	chardev_close(chardev_in);
 	if (sess_in)
 		async_hangup(sess_in);
Index: uspace/srv/net/tcp/service.c
===================================================================
--- uspace/srv/net/tcp/service.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/tcp/service.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <inet/endpoint.h>
 #include <inet/inet.h>
@@ -1095,5 +1096,5 @@
 	rc = tcp_conn_recv_impl(client, conn_id, data, size, &rsize);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_recv_wait_srv - recv_impl failed rc=%d", rc);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_recv_wait_srv - recv_impl failed rc=%s", str_error_name(rc));
 		async_answer_0(callid, rc);
 		async_answer_0(iid, rc);
Index: uspace/srv/net/udp/service.c
===================================================================
--- uspace/srv/net/udp/service.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/udp/service.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -570,5 +570,5 @@
 
 	rc = async_data_read_finalize(callid, &enext->epp.remote,
-	    max(size, (ssize_t)sizeof(inet_ep_t)));
+	    max(size, (size_t)sizeof(inet_ep_t)));
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
@@ -596,9 +596,9 @@
 {
 	ipc_callid_t callid;
-	ssize_t msg_size;
+	size_t msg_size;
 	udp_crcv_queue_entry_t *enext;
 	void *data;
 	size_t size;
-	ssize_t off;
+	size_t off;
 	int rc;
 
@@ -623,6 +623,11 @@
 	msg_size = enext->msg->data_size;
 
-	rc = async_data_read_finalize(callid, data, max(msg_size - off,
-	    (ssize_t)size));
+	if (off > msg_size) {
+		async_answer_0(callid, EINVAL);
+		async_answer_0(iid, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(callid, data, min(msg_size - off, size));
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
Index: uspace/srv/ns/clonable.c
===================================================================
--- uspace/srv/ns/clonable.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/ns/clonable.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 #include <assert.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <loader/loader.h>
 #include "clonable.h"
Index: uspace/srv/ns/service.c
===================================================================
--- uspace/srv/ns/service.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/ns/service.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include "service.h"
 #include "ns.h"
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/ns/task.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,7 +37,7 @@
 #include <errno.h>
 #include <assert.h>
+#include <macros.h>
 #include <stdio.h>
-#include <macros.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <types/task.h>
 #include "task.h"
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/taskmon/taskmon.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -51,5 +51,5 @@
 static void corecfg_client_conn(ipc_callid_t , ipc_call_t *, void *);
 
-static void fault_event(ipc_callid_t callid, ipc_call_t *call, void *arg)
+static void fault_event(ipc_call_t *call, void *arg)
 {
 	const char *fname;
@@ -150,6 +150,6 @@
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		printf("%s: Failed registering server (%d).\n",
-		    NAME, rc);
+		printf("%s: Failed registering server: %s.\n",
+		    NAME, str_error(rc));
 		return -1;
 	}
@@ -158,6 +158,6 @@
 	rc = loc_service_register(SERVICE_NAME_CORECFG, &sid);
 	if (rc != EOK) {
-		printf("%s: Failed registering service (%d).\n",
-		    NAME, rc);
+		printf("%s: Failed registering service: %s.\n",
+		    NAME, str_error(rc));
 		return -1;
 	}
Index: uspace/srv/test/chardev-test/Makefile
===================================================================
--- uspace/srv/test/chardev-test/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/srv/test/chardev-test/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,35 @@
+#
+# Copyright (c) 2017 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+BINARY = chardev-test
+
+SOURCES = \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/test/chardev-test/main.c
===================================================================
--- uspace/srv/test/chardev-test/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/srv/test/chardev-test/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,261 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <async.h>
+#include <errno.h>
+#include <str_error.h>
+#include <io/chardev_srv.h>
+#include <ipc/services.h>
+#include <loc.h>
+#include <mem.h>
+#include <stdio.h>
+#include <task.h>
+
+#define NAME  "chardev-test"
+
+static int smallx_open(chardev_srvs_t *, chardev_srv_t *);
+static int smallx_close(chardev_srv_t *);
+static int smallx_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int smallx_read(chardev_srv_t *, void *, size_t, size_t *);
+
+static int largex_open(chardev_srvs_t *, chardev_srv_t *);
+static int largex_close(chardev_srv_t *);
+static int largex_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int largex_read(chardev_srv_t *, void *, size_t, size_t *);
+
+static int partialx_open(chardev_srvs_t *, chardev_srv_t *);
+static int partialx_close(chardev_srv_t *);
+static int partialx_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int partialx_read(chardev_srv_t *, void *, size_t, size_t *);
+
+static service_id_t smallx_svc_id;
+static chardev_srvs_t smallx_srvs;
+
+static service_id_t largex_svc_id;
+static chardev_srvs_t largex_srvs;
+
+static service_id_t partialx_svc_id;
+static chardev_srvs_t partialx_srvs;
+
+static chardev_ops_t chardev_test_smallx_ops = {
+	.open = smallx_open,
+	.close = smallx_close,
+	.write = smallx_write,
+	.read = smallx_read
+};
+
+static chardev_ops_t chardev_test_largex_ops = {
+	.open = largex_open,
+	.close = largex_close,
+	.write = largex_write,
+	.read = largex_read
+};
+
+static chardev_ops_t chardev_test_partialx_ops = {
+	.open = partialx_open,
+	.close = partialx_close,
+	.write = partialx_write,
+	.read = partialx_read
+};
+
+static void chardev_test_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	chardev_srvs_t *svc;
+	sysarg_t svcid;
+
+	svcid = IPC_GET_ARG2(*icall);
+	if (svcid == smallx_svc_id) {
+		svc = &smallx_srvs;
+	} else if (svcid == largex_svc_id) {
+		svc = &largex_srvs;
+	} else if (svcid == partialx_svc_id) {
+		svc = &partialx_srvs;
+	} else {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	chardev_conn(iid, icall, svc);
+}
+
+int main(int argc, char *argv[])
+{
+	int rc;
+
+	printf("%s: Character device test service\n", NAME);
+	async_set_fallback_port_handler(chardev_test_connection, NULL);
+
+	rc = loc_server_register(NAME);
+	if (rc != EOK) {
+		printf("%s: Failed registering server.: %s\n", NAME, str_error(rc));
+		return rc;
+	}
+
+	chardev_srvs_init(&smallx_srvs);
+	smallx_srvs.ops = &chardev_test_smallx_ops;
+	smallx_srvs.sarg = NULL;
+
+	chardev_srvs_init(&largex_srvs);
+	largex_srvs.ops = &chardev_test_largex_ops;
+	largex_srvs.sarg = NULL;
+
+	chardev_srvs_init(&partialx_srvs);
+	partialx_srvs.ops = &chardev_test_partialx_ops;
+	partialx_srvs.sarg = NULL;
+
+	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_SMALLX, &smallx_svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		return rc;
+	}
+
+	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_LARGEX, &largex_svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		return rc;
+	}
+
+	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_PARTIALX, &partialx_svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
+		return rc;
+	}
+
+
+	printf("%s: Accepting connections\n", NAME);
+	task_retval(0);
+	async_manager();
+
+	/* Not reached */
+	return 0;
+}
+
+static int smallx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int smallx_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int smallx_write(chardev_srv_t *srv, const void *data, size_t size,
+    size_t *nwritten)
+{
+	if (size < 1) {
+		*nwritten = 0;
+		return EOK;
+	}
+
+	*nwritten = 1;
+	return EOK;
+}
+
+static int smallx_read(chardev_srv_t *srv, void *buf, size_t size,
+    size_t *nread)
+{
+	if (size < 1) {
+		*nread = 0;
+		return EOK;
+	}
+
+	memset(buf, 0, 1);
+	*nread = 1;
+	return EOK;
+}
+
+static int largex_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int largex_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int largex_write(chardev_srv_t *srv, const void *data, size_t size,
+    size_t *nwritten)
+{
+	if (size < 1) {
+		*nwritten = 0;
+		return EOK;
+	}
+
+	*nwritten = size;
+	return EOK;
+}
+
+static int largex_read(chardev_srv_t *srv, void *buf, size_t size,
+    size_t *nread)
+{
+	if (size < 1) {
+		*nread = 0;
+		return EOK;
+	}
+
+	memset(buf, 0, size);
+	*nread = size;
+	return EOK;
+}
+
+static int partialx_open(chardev_srvs_t *srvs, chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int partialx_close(chardev_srv_t *srv)
+{
+	return EOK;
+}
+
+static int partialx_write(chardev_srv_t *srv, const void *data, size_t size,
+    size_t *nwritten)
+{
+	if (size < 1) {
+		*nwritten = 0;
+		return EOK;
+	}
+
+	*nwritten = 1;
+	return EIO;
+}
+
+static int partialx_read(chardev_srv_t *srv, void *buf, size_t size,
+    size_t *nread)
+{
+	if (size < 1) {
+		*nread = 0;
+		return EOK;
+	}
+
+	memset(buf, 0, 1);
+	*nread = 1;
+	return EIO;
+}
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,4 +44,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <stdbool.h>
@@ -76,5 +77,5 @@
 }
 
-static void notification_handler(ipc_callid_t callid, ipc_call_t *call, void *arg)
+static void notification_handler(ipc_call_t *call, void *arg)
 {
 	if (IPC_GET_ARG1(*call) == VFS_PASS_HANDLE)
@@ -122,7 +123,9 @@
 	port_id_t port;
 	rc = async_create_port(INTERFACE_PAGER, vfs_pager, NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Cannot create pager port: %s\n", NAME, str_error(rc));
 		return rc;
-		
+	}
+
 	/*
 	 * Set a connection handling function/fibril.
@@ -141,5 +144,5 @@
 	rc = service_register(SERVICE_VFS);
 	if (rc != EOK) {
-		printf("%s: Cannot register VFS service\n", NAME);
+		printf("%s: Cannot register VFS service: %s\n", NAME, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -194,10 +194,10 @@
 
 extern void vfs_op_pass_handle(task_id_t, task_id_t, int);
-extern int vfs_wait_handle_internal(bool);
+extern int vfs_wait_handle_internal(bool, int *);
 
 extern vfs_file_t *vfs_file_get(int);
 extern void vfs_file_put(vfs_file_t *);
 extern int vfs_fd_assign(vfs_file_t *, int);
-extern int vfs_fd_alloc(vfs_file_t **file, bool desc);
+extern int vfs_fd_alloc(vfs_file_t **file, bool desc, int *);
 extern int vfs_fd_free(int);
 
@@ -206,5 +206,5 @@
 extern int vfs_open_node_remote(vfs_node_t *);
 
-extern int vfs_op_clone(int oldfd, int newfd, bool desc);
+extern int vfs_op_clone(int oldfd, int newfd, bool desc, int *);
 extern int vfs_op_fsprobe(const char *, service_id_t, vfs_fs_probe_info_t *);
 extern int vfs_op_mount(int mpfd, unsigned servid, unsigned flags, unsigned instance, const char *opts, const char *fsname, int *outfd);
@@ -220,5 +220,5 @@
 extern int vfs_op_unlink(int parentfd, int expectfd, char *path);
 extern int vfs_op_unmount(int mpfd);
-extern int vfs_op_wait_handle(bool high_fd);
+extern int vfs_op_wait_handle(bool high_fd, int *out_fd);
 extern int vfs_op_walk(int parentfd, int flags, char *path, int *out_fd);
 extern int vfs_op_write(int fd, aoff64_t, size_t *out_bytes);
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs_file.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -192,5 +192,5 @@
 }
 
-static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, vfs_file_t **file, bool desc)
+static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, vfs_file_t **file, bool desc, int *out_fd)
 {
 	if (!vfs_files_init(vfs_data))
@@ -223,5 +223,6 @@
 			
 			fibril_mutex_unlock(&vfs_data->lock);
-			return (int) i;
+			*out_fd = (int) i;
+			return EOK;
 		}
 		
@@ -249,10 +250,22 @@
  *             in a descending order.
  *
- * @return First available file descriptor or a negative error
- *         code.
- */
-int vfs_fd_alloc(vfs_file_t **file, bool desc)
-{
-	return _vfs_fd_alloc(VFS_DATA, file, desc);
+ * @param[out] out_fd  First available file descriptor
+ *
+ * @return Error code.
+ */
+int vfs_fd_alloc(vfs_file_t **file, bool desc, int *out_fd)
+{
+	return _vfs_fd_alloc(VFS_DATA, file, desc, out_fd);
+}
+
+static int _vfs_fd_free_locked(vfs_client_data_t *vfs_data, int fd)
+{
+	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || !vfs_data->files[fd]) {
+		return EBADF;
+	}
+
+	int rc = vfs_file_delref(vfs_data, vfs_data->files[fd]);
+	vfs_data->files[fd] = NULL;
+	return rc;
 }
 
@@ -265,11 +278,5 @@
 
 	fibril_mutex_lock(&vfs_data->lock);	
-	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || !vfs_data->files[fd]) {
-		fibril_mutex_unlock(&vfs_data->lock);
-		return EBADF;
-	}
-	
-	rc = vfs_file_delref(vfs_data, vfs_data->files[fd]);
-	vfs_data->files[fd] = NULL;
+	rc = _vfs_fd_free_locked(vfs_data, fd);
 	fibril_mutex_unlock(&vfs_data->lock);
 	
@@ -308,8 +315,8 @@
 		return EBADF;
 	}
-	if (FILES[fd] != NULL) {
-		fibril_mutex_unlock(&VFS_DATA->lock);
-		return EEXIST;
-	}
+
+	/* Make sure fd is closed. */
+	(void) _vfs_fd_free_locked(VFS_DATA, fd);
+	assert(FILES[fd] == NULL);
 	
 	FILES[fd] = file;
@@ -422,5 +429,5 @@
 }
 
-int vfs_wait_handle_internal(bool high_fd)
+int vfs_wait_handle_internal(bool high_fd, int *out_fd)
 {
 	vfs_client_data_t *vfs_data = VFS_DATA;	
@@ -436,9 +443,9 @@
 
 	vfs_file_t *file;
-	int fd = _vfs_fd_alloc(vfs_data, &file, high_fd);
-	if (fd < 0) {
+	int rc = _vfs_fd_alloc(vfs_data, &file, high_fd, out_fd);
+	if (rc != EOK) {
 		vfs_node_delref(bh->node);
 		free(bh);
-		return fd;
+		return rc;
 	}
 	
@@ -447,5 +454,5 @@
 	vfs_file_put(file);
 	free(bh);
-	return fd;
+	return EOK;
 }
 
Index: uspace/srv/vfs/vfs_ipc.c
===================================================================
--- uspace/srv/vfs/vfs_ipc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs_ipc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,6 +41,7 @@
 	bool desc = IPC_GET_ARG3(*request);
 	
-	int ret = vfs_op_clone(oldfd, newfd, desc);
-	async_answer_0(rid, ret);
+	int outfd = -1;
+	int rc = vfs_op_clone(oldfd, newfd, desc, &outfd);
+	async_answer_1(rid, rc, outfd);
 }
 
@@ -279,6 +280,7 @@
 {
 	bool high_fd = IPC_GET_ARG1(*request);
-	int fd = vfs_op_wait_handle(high_fd);
-	async_answer_1(rid, EOK, fd);
+	int fd = -1;
+	int rc = vfs_op_wait_handle(high_fd, &fd);
+	async_answer_1(rid, rc, fd);
 }
 
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs_lookup.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -222,6 +222,6 @@
 	vfs_exchange_release(exch);
 	
-	if ((int) rc < 0)
-		return (int) rc;
+	if (rc != EOK)
+		return rc;
 	
 	unsigned last = *pfirst + *plen;
@@ -229,6 +229,6 @@
 	*plen = last - *pfirst;
 	
-	result->triplet.fs_handle = (fs_handle_t) rc;
-	result->triplet.service_id = (service_id_t) IPC_GET_ARG1(answer);
+	result->triplet.fs_handle = (fs_handle_t) IPC_GET_ARG1(answer);
+	result->triplet.service_id = base->service_id;
 	result->triplet.index = (fs_index_t) IPC_GET_ARG2(answer);
 	result->size = MERGE_LOUP32(IPC_GET_ARG4(answer), IPC_GET_ARG5(answer));
